addpath('../MatlabInterface/');
figure;
axis off;
[currentYaw , currentPitch] = moveHead(0,0,1);
[TimeSecond, TimeMicroSecond, Width, Height, NbChnls, imageData] = getImageBuffer();
while(1)
    [ts1, tms1 ,nbFaces, faceData] = getFaceDetectorData(); 
    cla;
    imagesc(imageData);drawnow;
    hold on;
    xLine = 0;
    xFace = [];
    yFace = [];
    if(nbFaces)
        rectangleHalfWidth = 40;
        xFace = radToPix(-faceData(1,:),Width);
        yFace = radToPix(faceData(2,:),Height);
        for i = 1:nbFaces
            line([xFace(i)-rectangleHalfWidth,xFace(i)-rectangleHalfWidth, xFace(i)+rectangleHalfWidth, xFace(i)+rectangleHalfWidth, xFace(i)-rectangleHalfWidth],...
                [yFace(i)-rectangleHalfWidth,yFace(i)+rectangleHalfWidth,yFace(i)+rectangleHalfWidth,yFace(i)-rectangleHalfWidth,yFace(i)-rectangleHalfWidth],...
                'linewidth',3);drawnow;
        end
    end
    
    if(nbFaces)
        x = 0;
        y = 0;
        xcenter = Width/2;
        ycenter = Height/2;
        bestDist = (x-xcenter)*(x-xcenter)+(y-ycenter)*(y-ycenter);
        index = 1;
        for i = 1:nbFaces
            xFace = radToPix(-faceData(1,i),Width);
            yFace = radToPix(faceData(2,i),Height);
            dist = (xFace-xcenter)*(xFace-xcenter)+(yFace-ycenter)*(yFace-ycenter);
            if(dist < bestDist)
                index = i;
                bestDist = dist;
            end
        end
        yawFace = faceData(1,index);
        pitchFace = faceData(2,index);
        if(abs(yawFace -currentYaw) > 0.02)
            newYaw = yawFace;
        else
            newYaw = currentYaw;
        end
        if(abs(pitchFace -currentPitch) > 0.02)
            newPitch = pitchFace;
        else
            newPitch = currentPitch;
        end
        [currentYaw , currentPitch] = moveHead(newYaw,newPitch,0);
    end
    
    ts = TimeSecond;
    tms = TimeMicroSecond;
    while(ts == TimeSecond && tms == TimeMicroSecond)
        [TimeSecond, TimeMicroSecond, Width, Height, NbChnls, imageData] = getImageBuffer();
    end
end
close all;