/* ============================================================
 *
 * This file is a part of the EARS project
 * Copyright (c) INRIA 2015
 *
 * Contributor (s) : Fabien Badeig
 * Contacts :
 * perception-naolab@inria.fr
 *
 * This file is part of NaoLab.
 *
 * NaoLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * NaoLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with NaoLab. If not, see <http://www.gnu.org/licenses/>.
 *
 * This project is headed by Perception research team at INRIA.
 *
 * ============================================================*/

/**
* @file getImageBuffer.cpp
* @author Fabien Badeig
* @date May 2015
* @brief
**/

#include <math.h>
#include "mex.h"
#include "dataproxies.h"

void mexFunction(int nlhs, mxArray *plhs[ ], int nrhs, const mxArray *prhs[ ])
{
    int ts0 = 0;
    int tms0 = 0;
    int width0 = DataProxy::IMAGEWIDTH;
    int height0 = DataProxy::IMAGEHEIGHT;
    int nbChannels0 = DataProxy::IMAGENBCHANNELS;

    // Build outputs
    mwSize dims0[3] = {height0, width0, nbChannels0};
    plhs[5] = mxCreateNumericArray(3, dims0,  mxUINT8_CLASS, mxREAL);
    unsigned char *D0 = (unsigned char *)mxGetData(plhs[5]);

    int ts1 = 0;
    int tms1 = 0;
    int width1 = DataProxy::IMAGEWIDTH;
    int height1 = DataProxy::IMAGEHEIGHT;
    int nbChannels1 = DataProxy::IMAGENBCHANNELS;

    // Build outputs
    mwSize dims1[3] = {height1, width1, nbChannels1};
    plhs[11] = mxCreateNumericArray(3, dims1,  mxUINT8_CLASS, mxREAL);
    unsigned char *D1 = (unsigned char *)mxGetData(plhs[11]);

    DataProxy::getImages(ts0, tms0, width0, height0, nbChannels0, D0, ts1, tms1, width1, height1, nbChannels1, D1, DataProxy::MATLABRGB );

    // Build outputs
    plhs[0] = mxCreateDoubleScalar(ts0);
    plhs[1] = mxCreateDoubleScalar(tms0);
    plhs[2] = mxCreateDoubleScalar(width0);
    plhs[3] = mxCreateDoubleScalar(height0);
    plhs[4] = mxCreateDoubleScalar(nbChannels0);

    plhs[6] = mxCreateDoubleScalar(ts1);
    plhs[7] = mxCreateDoubleScalar(tms1);
    plhs[8] = mxCreateDoubleScalar(width1);
    plhs[9] = mxCreateDoubleScalar(height1);
    plhs[10] = mxCreateDoubleScalar(nbChannels1);

}
