/* ============================================================
 *
 * This file is a part of the EARS project
 * Copyright (c) INRIA 2015
 *
 * Contributor (s) : Fabien Badeig
 * Contacts :
 * perception-naolab@inria.fr
 *
 * This file is part of NaoLab.
 *
 * NaoLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * NaoLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with NaoLab. If not, see <http://www.gnu.org/licenses/>.
 *

 * This project is headed by Perception research team at INRIA.
 *
 * ============================================================*/

/**
* @file moveTo.cpp
* @author Fabien Badeig
* @date 2015 May
* @brief Mex function to control remotely Nao motors from Matlab
**/

#include <math.h>
#include "mex.h"
#include "dataproxies.h"

/** moveToPoint(x,y,theta);
  * @param  x,y position to reach on the plane
  * @param  theta rotation of NAO
 **/
void mexFunction(int nlhs, mxArray *plhs[ ], int nrhs, const mxArray *prhs[ ])
{
    if (nrhs != 3) {
        mexPrintf("usage : moveToPoint(x,y,theta).\n");
        return;
    }

    float xp = mxGetScalar(prhs[0]);
    float yp = mxGetScalar(prhs[1]);
    float tp = mxGetScalar(prhs[2]);

    DataProxy::moveToPoint(xp, yp, tp);

}
